using System;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
using System.Data;

using Cosmos.Win;
using Cosmos.BaseFrame;
using Cosmos.UserFrame;
using Cosmos.ServiceProvider;
using Cosmos.Common;
using Cosmos.CommonManager;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 해피포인트 쿠폰(인카드쿠폰)
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Win
{
    public partial class frmPntHappyCpn : frm_PayMainBack
    {

        #region 변수 선언

        private SManager sManager = new SManager();                                 // 이 객체를 통해 업무 Service 호출
        private StateServer StateObject = (StateServer)StateServer.GetInstance();   // StateObject : StateServer Object (객체)
        private PosStatus m_cPosStatus = new PosStatus();                           // 기본정보 참조
        private TranStatus m_cTrnStatus = new TranStatus();                         // 거래정보 참조        
        private DeviceStatus m_cDevStatus = new DeviceStatus();                     // 디바이스 관리
        private PosOLEDevice.DelegateOlePos delegatePos;
        private PosOLEDevice.DelegateIcReader delegateReader;                       // IC리더 콜백
        //#20170918 IC 콜백 함수 변경 start
        //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
        /*
        private PosOLEDevice.CallbackIc delegateReaderCardInfo;                     // IC리더 콜백(CardInfo)
        private bool m_bCardInPut;                                                  //카드 입력 중복 방지
        private string m_sIcChip;                                                   //IC CHIP DATA(EMV)
        private string m_InputType = ""; //PosConst.POS_VAN_MASTER.VAN_KEYIN;       //입력구분
        private string m_sCardNo;                                                   //입력 카드 번호
        private string m_sFallDiv;                                                  //FallBack구분
        private string m_sServiceCode;                                              //서비스코드
        */
        //#20170918 IC 콜백 함수 변경 end

        private IICReaderUs m_cDeviceICReader = null;
        private ISignPadUs m_cDeviceSignPad = null;
        private IDataProcessUs m_cDataService = null;                               // 거래데이터 합계금액 계산 및 관리
        private IDataCommonUs m_cDataCommon = null;                                 // POS 공통함수 인터페이스
        private IPaymentUs m_cHappyCoupon = null;
        
        private bool bNotDoubleClik = false;                                        // 더블 클릭 방지용

        private string m_sPosMenuKey;
        /// <summary>
        /// POS 기능키
        /// </summary>
        public string SetPosMenuKey { set { this.m_sPosMenuKey = value; } }

        /// <summary>
        /// 입력구분
        /// </summary>
        private string m_sInPutType = "";
        /// <summary>
        /// 입력데이터
        /// </summary>
        private string m_sInPutData = "";
        /// <summary>
        /// 마스킹데이터
        /// </summary>
        private string m_sInMaskData = "";
        /// <summary>
        /// 카드데이터(암호화)
        /// </summary>
        private string m_sInEncData = "";

        /// <summary>
        /// 대상 금액
        /// </summary>
        private double m_nDestAmt = 0;
        /// <summary>
        /// 상품 선택 행(-1:전체)
        /// </summary>
        private string m_sSelRow = "-1";

        /// <summary>
        /// 쿠폰리스트 데이터
        /// </summary>
        private DataTable m_dtGridList;
        /// <summary>
        /// 인카드 쿠폰 코드
        /// </summary>
        private string m_sInCardCoupon = "";
        
        #endregion 변수 선언

        #region 생성자 & 소멸자 & 폼초기화
        public frmPntHappyCpn()
        {
            InitializeComponent();

            base.SetStyle(ControlStyles.OptimizedDoubleBuffer | ControlStyles.AllPaintingInWmPaint | ControlStyles.ResizeRedraw, true);
            //this.UpdateStyles();

            m_cPosStatus = (PosStatus)StateObject.POS;      // POS 기본정보
            m_cTrnStatus = (TranStatus)StateObject.TRAN;    // POS 거래정보 
            m_cDevStatus = (DeviceStatus)StateObject.DEVICE;

            m_cDeviceICReader = (IICReaderUs)sManager.InitServiceInstance(ServiceLists.AGENT_OLEDEVICE.DLL, ServiceLists.AGENT_OLEDEVICE.DEVICE_ICREADER);
            m_cDeviceSignPad = (ISignPadUs)sManager.InitServiceInstance(ServiceLists.AGENT_OLEDEVICE.DLL, ServiceLists.AGENT_OLEDEVICE.DEVICE_SIGNPAD);
            m_cDataService = (IDataProcessUs)sManager.InitServiceInstance(ServiceLists.ASV_DATA_PROCESS.DLL, ServiceLists.ASV_DATA_PROCESS.DATA_SERVICE);
            m_cDataCommon = (IDataCommonUs)sManager.InitServiceInstance(ServiceLists.ASV_DATA_PROCESS.DLL, ServiceLists.ASV_DATA_PROCESS.DATA_COMMON);
            m_cHappyCoupon = (IPaymentUs)sManager.InitServiceInstance(ServiceLists.BSV_PAYMENT.DLL, ServiceLists.BSV_PAYMENT.POINTHAPPYCOUPON);

            delegatePos = new PosOLEDevice.DelegateOlePos(OnDeviceEvent);
            delegateReader = new PosOLEDevice.DelegateIcReader(OnIcReaderCallBack);     // IC리더 콜백
            //#20170918 IC 콜백 함수 변경 start
            //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
            //delegateReaderCardInfo = new PosOLEDevice.CallbackIc(OnIcReaderCallBackCardInfo);     // IC리더 콜백(CardInfo)
            //#20170918 IC 콜백 함수 변경 end
        }

        private void frmPointHappyCpn_Load(object sender, EventArgs e)
        {
            UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                        System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", "");
            InitControl();

            tmrIcCard.Tag = "";
            tmrIcCard.Enabled = true;   // IC리더 콜백 설정
        }

        private void frmPointHappyCpn_Activated(object sender, EventArgs e)
        {
            PosOLEDevice.SetEventHandle(delegatePos);
        }

        private void frmPointHappyCpn_Deactivate(object sender, EventArgs e)
        {
            PosOLEDevice.SetEventHandle(null);  
        }

        private void frmPointHappyCpn_FormClosing(object sender, FormClosingEventArgs e)
        {
            tmrIcCard.Tag = "CLOSE";
            // 마우스(이중클릭방지)
            Point nPoint = System.Windows.Forms.Cursor.Position;
            Cursor.Clip = new System.Drawing.Rectangle(1024, 0, 1, 1);

            if (m_sPosMenuKey != PosKey.MENU_KEY.HAPPY_DC_COUPON) FormManager.SetFormAllControlMove(this, 216, 123);

            UnRegIcCallback();          // IC리더 콜백 해지
            UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", lblTitle.Text);

            // 마우스(이중클릭방지)
            Cursor.Clip = Screen.PrimaryScreen.Bounds;
            Cursor.Position = nPoint;
        }

        /// <summary>
        /// 폼 컨트롤 초기화
        /// </summary>
        private void InitControl()
        {
            try
            {
                
                // 이미지 로딩 처리
                
                FormManager.SetFormAllControlFont(this, m_cPosStatus.Base.FONT);
                FormManager.SetTextBoxGlobalInfo(this, m_cPosStatus.Global.m_stCultureMaster.nGroupingDigits, m_cPosStatus.Global.m_stCultureMaster.strGroupingSymbol
                    , m_cPosStatus.Global.m_stCultureMaster.nDecimalDigits, m_cPosStatus.Global.m_stCultureMaster.strDecimalSymbol);

                if (m_sPosMenuKey == PosKey.MENU_KEY.HAPPY_DC_COUPON)
                {
                    this.Location = new Point(0, 50);

                    //#20181015 결제창 엑박 관련 이미지 미사용 처리 start
                    //기존
                    //picBack.Image = ImageManager.GetImage(BaseCom.NxImgPath, ImageManager.PAY_MAIN_BACKGROUND);
                    //#20181015 결제창 엑박 관련 이미지 미사용 처리 end

                    this.Size = new Size(1024, 525);
                    picBack.Size = new Size(1024, 525);
                    btnEnter.Visible = true;
                }
                else
                {
                    FormManager.SetFormAllControlMove(this, -216, -123);

                    //#20181015 결제창 엑박 관련 이미지 미사용 처리 start
                    //기존
                    //picBack.Image = ImageManager.GetImage(BaseCom.NxImgPath, ImageManager.POP_SIZE_S);
                    //#20181015 결제창 엑박 관련 이미지 미사용 처리 end

                    FormManager.MovePopUpForm(this, false, m_cPosStatus.Sale.ScreenSizeUser);
                    btnEnter.Visible = false;
                }

                btnEnter.BackColor = CmUtil.GetColorToString(m_cPosStatus.ScnMst.ThemeColor);

                //버튼이미지 적용
                btnUp.Image         = ImageManager.GetImage(BaseCom.NxImgPath, ImageManager.NAVIBTN_14X9_UP1_BASIC);
                btnUp.ImageAlign    = ContentAlignment.MiddleCenter;
                btnUp.BorderStyle   = BorderStyle.None;
                btnDown.Image       = ImageManager.GetImage(BaseCom.NxImgPath, ImageManager.NAVIBTN_14X9_DOWN1_BASIC);
                btnDown.ImageAlign  = ContentAlignment.MiddleCenter;
                btnDown.BorderStyle = BorderStyle.None;

                if (btnUp.Image != null) btnUp.Text = "";
                if (btnDown.Image != null) btnDown.Text = "";

                btnExit.Image = ImageManager.GetImage(BaseCom.NxImgPath, ImageManager.BTN_CLOSE);
                if (btnExit.Image != null) btnExit.Text = "";

                lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0138);
                lblCardNo.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0139);
                lblPayAmt.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0098);

                btnIcCard.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0132);
                btnRfCard.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0580);
                btnSearch.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0004);
                btnEnter.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0057);
                btnPopCard.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0878);

                // 기능 버튼 설정 체크
                FormManager.SetbtnMenu(txtCardNo, m_cDevStatus.ICReader.UseYn, btnIcCard, btnRfCard, btnPopCard, btnPinPad);

                m_sSelRow = "-1";
                m_nDestAmt = m_cDataService.GetPluTagetAmount(PosKey.MENU_KEY.HAPPY_DC_COUPON);     // 대상 금액
                //m_nDestAmt = m_cTrnStatus.Sale.RemainPayAmt;     // 대상 금액
                txtPayAmt.Text = m_cPosStatus.Global.NumericTOCurrency(m_nDestAmt);
                
                InitializeGrid();
                InitPayMainBack(m_cPosStatus, m_cDataCommon, m_sPosMenuKey, PosConst.MOT_MSG_TYPE.PAY_STEP_2, "");

                ClearCardInfo();                // 카드 입력 정보 클리어
                bNotDoubleClik = false;

                m_sInCardCoupon = "";

                // 무결성 실패후 진행시 오류 메시지 표시
                if (m_cDevStatus.ICReader.UseYn == true)     // 여신전문금융업법 적용여부 체크
                {
                    //#20171208, RF버튼 선택 시에만 서명패드 무결성 체크하도록 수정 Start
                    /*(if (m_cDevStatus.ICReader.Integrity_IC_Status != true && m_cDevStatus.ICReader.UseYn == true && m_cDevStatus.ICReader.Integrity_SignPad_Status != true && m_cDevStatus.SignPad.UseYn == true) WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0388);
                    else
                    {
                        if (m_cDevStatus.ICReader.Integrity_IC_Status != true && m_cDevStatus.ICReader.UseYn == true) WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0384);
                        if (m_cDevStatus.ICReader.Integrity_SignPad_Status != true && m_cDevStatus.SignPad.UseYn == true) WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0385);
                    }*/
                    if (m_cDevStatus.ICReader.Integrity_IC_Status != true && m_cDevStatus.ICReader.UseYn == true) WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0384);
                    //#20171208, RF버튼 선택 시에만 서명패드 무결성 체크하도록 수정 End
                }

                // 해피포인트 카드 등록 여부 체크
                ArrayList alTrEtc = (ArrayList)StateObject.GetItemObject(Column.TR_ETC.ITEM);
                foreach (Column.TR_ETC.DATA cEtcItem in alTrEtc)
                {
                    if (cEtcItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL) continue;

                    if (cEtcItem.ETC_WAY_CD == ItemConst.TR_ITEM_ID.ETC_INFO_ITEM && cEtcItem.ETC_DTL_CD_01 == ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT)
                    {
                        if (cEtcItem.HP_CPN_INFO != null)
                        {
                            m_sInPutType = cEtcItem.OCCUR_ENTRY_05;      // 입력구분
                            m_sInPutData = cEtcItem.OCCUR_ENTRY_01;      // 입력데이터
                            m_sInMaskData = cEtcItem.OCCUR_ENTRY_01;     // 마스킹
                            m_sInEncData = cEtcItem.CanFiller1;          // 카드데이터

                            txtCardNo.Value = m_sInPutData;
                            SearchTxtInPut("1", cEtcItem.HP_CPN_INFO);
                        }
                        break;
                    }
                }

                txtCardNo.Value = m_sInPutData;
                txtCardNo.ReadOnly = false;

                txtCardNo.Select();
                txtCardNo.SelectText();
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        /// <summary>
        /// 그리드 초기화
        /// </summary>
        private void InitializeGrid()
        {
            try
            {
                gridList.CsmGridColumnHeadersFont = new Font(m_cPosStatus.Base.FONT, 10, gridList.CsmGridColumnHeadersFont.Style);

                //DataGridView 자체의 컬럼 헤더 Visible 여부
                gridList.CsmGridColumnHeadersVisible = true;
                //DataGridView 자체의 컬럼 헤더 높이
                gridList.CsmGridColumnHeadersHeight = 32;
                gridList.CsmGridRowsHeight = 33;

                //그리드의 컬럼 수
                gridList.CsmGridColumnCount = 4;
                //그리드의 한 화면에 보이는 로우수
                gridList.CsmGridShowPageRowsCount = 4;

                gridList.CsmGridSetHeaderBackColor(236, 238, 239);                             //그리드 헤더 배경색
                gridList.CsmGridDefaultRowBackColor = Color.FromArgb(255, 255, 255);           //그리드 홀수(Default)행의 배경색 지정
                gridList.CsmGridAlternateRowBackColor = Color.FromArgb(251, 253, 255);         //그리드 짝수(Alternate)행의 배경색 지정
                gridList.CsmGridBackGroundColor = Color.FromArgb(251, 253, 255);               //기본 백그라운드 컬러
                gridList.CsmGridHighlightColor = Color.FromArgb(255, 251, 211);                //그리드 선택 백 컬러
                gridList.CsmGridHighlightTextColor = Color.Black;                              //그리드 선택 글자 컬러

                //각 컬럼별 이름 지정
                gridList.CsmGridColumnName(0, MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0139));
                gridList.CsmGridColumnName(1, MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0140));
                gridList.CsmGridColumnName(2, MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0141));
                gridList.CsmGridColumnName(3, MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0142));

                //컬럼넓이 지정(406)
                gridList.CsmGridSetColumnWidth(new int[] { 100, 130, 89, 89 });

                //컬럼 정렬 0:왼쪽, 1:가운데, 2:오른쪽
                gridList.CsmGridAlignment(new int[] { 0, 0, 0, 0 });

                m_dtGridList = new DataTable("GRID_LIST");
                m_dtGridList.Columns.Add(new DataColumn("COUPON_CD", typeof(string)));
                m_dtGridList.Columns.Add(new DataColumn("COUPON_NM", typeof(string)));
                m_dtGridList.Columns.Add(new DataColumn("START_DT", typeof(string)));
                m_dtGridList.Columns.Add(new DataColumn("END_DT", typeof(string)));
                
                m_dtGridList.Clear();
                gridList.CsmGridDataSource = m_dtGridList;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        /// <summary>
        /// 카드 입력 정보 클리어
        /// </summary>
        private void ClearCardInfo()
        {
            try
            {
                m_sInPutType = "";      // 입력구분
                m_sInPutData = "";      // 입력데이터
                m_sInMaskData = "";     // 마스킹
                m_sInEncData = "";      // 카드데이터
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        #endregion

        #region 버튼 입력 처리
        /// <summary>
        /// 버튼 입력 처리
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnProc_Click(object sender, EventArgs e)
        {
            try
            {
                if (bNotDoubleClik) return;
                bNotDoubleClik = true;

                if (((Cosmos.UI.CsmButton)sender) == btnIcCard)             // 카드입력
                {
                    if (GetIcCardData(e != null ? true : false) == true)
                    {
                        SearchTxtInPut("1", null);
                    }
                }
                else if (((Cosmos.UI.CsmButton)sender) == btnRfCard)        // 카드입력
                {
                    UnRegIcCallback(); // IC리더 콜백 해지
                    if (GetRfCardData() == true)
                    {
                        SearchTxtInPut("1", null);
                    }
                    if (txtCardNo.Value == "") tmrIcCard.Enabled = true;
                }
                else if (((Cosmos.UI.CsmButton)sender) == btnPopCard)        // POP카드
                {
                    UnRegIcCallback(); // IC리더 콜백 해지
                    if (GetPopCardData() == true)
                    {
                        SearchTxtInPut("1", null);
                    }
                    if (txtCardNo.Value == "") tmrIcCard.Enabled = true;
                }
                else if (((Cosmos.UI.CsmButton)sender) == btnPinPad)        // 핀패드
                {
                    UnRegIcCallback(); // IC리더 콜백 해지
                    if (GetPinPadData() == true)
                    {
                        SearchTxtInPut("1", null);
                    }
                    if (txtCardNo.Value == "") tmrIcCard.Enabled = true;
                }
                else if (((Cosmos.UI.CsmButton)sender) == btnSearch)        // 조회
                {
                    SearchTxtInPut("", null);
                }
                else if (((Cosmos.UI.CsmButton)sender) == btnEnter)         // 승인
                {
                    CompleteTxtInPut();
                }
                else if (((Cosmos.UI.CsmButton)sender) == btnUp)
                {
                    gridList.CsmGridScroll("UP");
                }
                else if (((Cosmos.UI.CsmButton)sender) == btnDown)
                {
                    gridList.CsmGridScroll("DOWN");
                }
                else if (((Cosmos.UI.CsmButton)sender) == btnExit)
                {
                    bNotDoubleClik = false;

                    this.DialogResult = DialogResult.Cancel;
                    this.Close();
                    return;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                bNotDoubleClik = false;
            }
            bNotDoubleClik = false;
        }
        #endregion

        #region 텍스트박스 키 입력 이벤트 처리
        /// <summary>
        /// 텍스트박스 키 입력 이벤트 처리
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="sFuncValue"></param>
        private void txtEditBox_EditBoxKeyDownEvent(object sender, string sFuncValue)
        {
            try
            {
                if (bNotDoubleClik) return;
                bNotDoubleClik = true;

                if (sFuncValue == PosKey.MENU_KEY.ENTER)
                {
                    if (((Cosmos.UI.CsmPosEditBox)sender) == txtCardNo)
                    {
                        if (txtCardNo.Text == "")
                        {
                            if (GetIcCardData(true) == false)
                            {
                                bNotDoubleClik = false;
                                return;   // 카드정보 읽기
                            }
                            SearchTxtInPut("1", null);       // 인카드쿠폰조회
                            bNotDoubleClik = false;
                            return;
                        }

                        if (CheckTxtInPut(sender) == false)
                        {
                            bNotDoubleClik = false;
                            return;
                        }
                        if (m_sInPutData.Length >= 15)
                            SearchTxtInPut("", null);       // 인카드쿠폰조회
                        else
                        
                        CompleteTxtInPut();             // 쿠폰승인
                    }
                }
                else if (sFuncValue == PosKey.MENU_KEY.CLEAR)
                {
                    if (((Cosmos.UI.CsmPosEditBox)sender) == txtCardNo)
                    {
                        ClearCardInfo();        // 카드 입력 정보 클리어
                        tmrIcCard.Enabled = true;
                    }

                    if (((Cosmos.UI.CsmPosEditBox)sender).ReadOnly == false) ((Cosmos.UI.CsmPosEditBox)sender).Text = "";
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                bNotDoubleClik = false;
            }
            bNotDoubleClik = false;
        }

        /// <summary>
        /// 텍스트박스 활성화 처리
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtEditBox_EnterEvent(object sender, EventArgs e)
        {
            try
            {
                padInPut.SetActiveControl = (Control)sender;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        #endregion

        #region 텍스트박스 입력 유효성 체크
        /// <summary>
        /// 텍스트박스 입력 유효성 체크
        /// </summary>
        /// <param name="sender"></param>
        /// <returns></returns>
        private bool CheckTxtInPut(object sender)
        {
            try
            {
                // 특정 문자값 제거
                try
                {
                    if (m_cDevStatus.Msr.STX != "" && txtCardNo.Value.StartsWith(m_cDevStatus.Msr.STX)) txtCardNo.Value = txtCardNo.Value.Substring(1);

                    int iLastEtx = txtCardNo.Value.LastIndexOf(m_cDevStatus.Msr.ETX);
                    if (m_cDevStatus.Msr.ETX != "" && iLastEtx > 0) txtCardNo.Value = CmUtil.MidH(txtCardNo.Value, 0, iLastEtx);
                }
                catch { }
                
                // 카드번호 길이 체크
                if (sender == null || ((Cosmos.UI.CsmPosEditBox)sender) == txtCardNo)
                {
                    if (txtCardNo.Value.Length < 10)
                    {
                        WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0080);
                        txtCardNo.Focus();
                        return false;
                    }

                    // 입력된 카드번호 변경 체크
                    if (txtCardNo.Value != m_sInPutData)
                    {
                        ClearCardInfo();        // 카드 입력 정보 클리어
                    }

                    if (m_sInEncData == "")
                    {
                        if (m_sInPutData == "")
                        {
                            m_sInPutData = txtCardNo.Value;
                            if (m_sInPutData.Length > 16 && CmUtil.IsNumber(m_sInPutData.Substring(16, 1)) == false)
                            {
                                if (CmUtil.CheckHappyMobileCard(m_sInPutData) == false)
                                {
                                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0037);
                                    ClearCardInfo();        // 카드 입력 정보 클리어
                                    txtCardNo.Focus();
                                    txtCardNo.SelectText();
                                    return false;
                                }
                                m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_MOBILE_SWIP;
                                txtCardNo.Value = m_sInPutData; // .Substring(0, 16);
                            }
                            else
                            {
                                m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_KEYIN;
                            }
                            if (m_sInPutData.Contains("=") == true) m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;
                        }
                        if (EncryptedCardNo(m_sInPutData, ref m_sInMaskData, ref m_sInEncData) == false) return false;
                    }
                }
                return true;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }
        #endregion

        #region 입력 완료 처리
        /// <summary>
        /// 해피포인트 인카드쿠폰 및 쿠폰 조회 처리
        /// </summary>
        /// <param name="sSearchDiv">0:해피쿠폰조회, 1:인카드쿠폰조회</param>
        /// <param name="aHP_CPN_INFO"></param>
        /// <returns></returns>
        private bool SearchTxtInPut(string sSearchDiv, ArrayList aHP_CPN_INFO)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                if (CheckTxtInPut(null) == false) return false;

                // 15자리 이상이면 카드번호 인식 하여 인카드 쿠폰 조회 처리
                if (sSearchDiv == "") sSearchDiv = m_sInPutData.Length >= 15 ? "1" : "0";

                if (sSearchDiv == "1")
                {
                    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                    // 인카드 쿠폰 조회 
                    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                    m_sInCardCoupon = "";

                    // 인카드 쿠폰 리스트 조회
                    m_dtGridList.Clear();
                    gridList.CsmGridDataSource = m_dtGridList;

                    if ( aHP_CPN_INFO == null)
                    { 
                        // 조회
                        string[] saRecvdData = null;
                        sRet = m_cHappyCoupon.SearchPayment(new string[] { m_sInPutType, m_sInMaskData, m_sInEncData, sSearchDiv }, ref saRecvdData);
                        if (sRet == UserCom.RST_OK)
                        {
                            Column.TR_PAYMENT.DATA cPayItem = (Column.TR_PAYMENT.DATA)m_cHappyCoupon.GetPayment(new string[] { });
                            aHP_CPN_INFO = cPayItem.HP_CPN_INFO;
                        }
                    }

                    if ( aHP_CPN_INFO != null)
                    {
                        foreach (string[] sInfo in aHP_CPN_INFO)
                        {
                            DataRow drNewRow = m_dtGridList.NewRow();
                            drNewRow["COUPON_CD"] = sInfo[0];
                            
                            
                            //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 start, phj
                            //기존
                            //drNewRow["COUPON_NM"] = sInfo[1];
                            //변경
                            drNewRow["COUPON_NM"] = CmUtil.MidH(sInfo[1], 0, 40);
                            //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 end, phj

                            drNewRow["START_DT"] = m_cPosStatus.Global.DateToCulture(sInfo[2]);
                            drNewRow["END_DT"] = m_cPosStatus.Global.DateToCulture(sInfo[3]);

                            m_dtGridList.Rows.Add(drNewRow);
                        }
                    }
                    gridList.CsmGridDataSource = m_dtGridList;
                    gridList.CsmGridSelectRow(0);

                    txtCardNo.Text = "";
                }
                else
                {
                    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                    // 해피 쿠폰 조회 
                    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                    string[] saRecvdData = null;
                    sRet = m_cHappyCoupon.SearchPayment(new string[] { m_sInPutType, m_sInMaskData, m_sInEncData, sSearchDiv }, ref saRecvdData);
                    if (sRet == UserCom.RST_OK)
                    {
                        Column.TR_PAYMENT.DATA cPayItem = (Column.TR_PAYMENT.DATA)m_cHappyCoupon.GetPayment(new string[] { });

                        WinManager.ConfirmMessage(cPayItem.CanFiller2);
                        //WinManager.ConfirmMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0138) + " : " + cPayItem.CanFiller2);
                    }

                    txtCardNo.SelectText();
                }

                if (sRet == UserCom.RST_OK) return true;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }

        /// <summary>
        /// 해피포인트 쿠폰 등록 처리
        /// </summary>
        /// <param name="nFlowMode"></param>
        /// <returns></returns>
        private bool CompleteTxtInPut()
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                if (m_sPosMenuKey != PosKey.MENU_KEY.HAPPY_DC_COUPON) return false;

                if (CheckTxtInPut(null) == false) return false;

                //if (m_sInPutData.Length < 10 || m_sInPutData.Length > 16)
                //{
                //    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0080);
                //    txtCardNo.SelectText();
                //    return false;
                //}

                // 해피쿠폰 조회
                string[] saRecvdData = null;
                sRet = m_cHappyCoupon.SearchPayment(new string[] { m_sInPutType, m_sInPutData, m_sInEncData, "0" }, ref saRecvdData);
                if (sRet != UserCom.RST_OK)
                {
                    txtCardNo.SelectText();
                    return false;
                }
                
                Column.TR_PAYMENT.DATA cPayItem = (Column.TR_PAYMENT.DATA)m_cHappyCoupon.GetPayment(new string[] { });
                if (m_sInCardCoupon != m_sInPutData)
                {
                    //string sMsg = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0138) + " : " + cPayItem.CanFiller2 + PosConst.CRLF
                    //            + MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0130);
                    string sMsg = cPayItem.CanFiller2 + PosConst.CRLF + MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0130);
                    if (WinManager.QuestionMessage(sMsg) == false)
                    {
                        txtCardNo.SelectText();
                        return false;
                    }
                }

                //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 start, phj
                #region 쿠폰 조회 응답전문의 코드 유무 체크 (코드 존재 시 제품군인지 상품코드인지 체크) 
                //기존
                /*
                string sChoicePluYN = PosMstManager.GetPosOption(POS_OPTION.OPT324);      // 상품선택여부(0:상품미선택, 1:상품선택)
                if (sChoicePluYN == "1")
                {
                    // 상품 선택 쿠폰 이면 상품 선택 처리
                    if (ChoicePluItem() == false) return false;
                }
                else
                {
                    // 전체금액 대상
                    m_sSelRow = "-1";           
                }
                */

                //변경
                //내려온 제품군 또는 상품코드가 존재 할 때
                if (cPayItem.CpnItemDcCode != "")
                {
                    UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                      System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                      System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                      "Online Coupon Group Code : " + cPayItem.CpnItemDcCode);

                    // 제품군 코드가 내려왔으면  제품군에 속하고, 등록 된 상품을 화면에 보여주고, 사용자가 선택한 제품 할인적용.
                    // 상품코드가 내려왔으면 바로 해당 상품으로 할인적용.
                    if (ChoiceCpnItem(cPayItem.CpnItemDcCode) == false)
                    {
                        WinManager.ConfirmMessage(POS_MESSAGE.ERROR.MSG_0741);
                        return false;
                    }
                }
                //내려온 제품군 또는 상품코드가 존재하지 않을 때
                else
                {
                    UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                      System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                      System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                      "No Online Coupon Group Code ");

                    string sChoicePluYN = PosMstManager.GetPosOption(POS_OPTION.OPT324);      // 상품선택여부(0:상품미선택, 1:상품선택)
                    if (sChoicePluYN == "1")
                    {
                        // 상품 선택 쿠폰 이면 상품 선택 처리
                        if (ChoicePluItem() == false) return false;
                    }
                    else
                    {
                        // 전체금액 대상
                        m_sSelRow = "-1";
                    }
                }
                #endregion 
                //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 end, phj

                // 해피포인트 쿠폰 등록 처리
                sRet = m_cHappyCoupon.SetPayment(new string[] { m_sInPutType, m_sInPutData, m_sInEncData, m_nDestAmt.ToString(), m_sSelRow });
                if (sRet != UserCom.RST_OK)
                {
                    txtCardNo.SelectText();
                    return false;
                }

                this.DialogResult = DialogResult.OK;
                this.Close();

                return true;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }


        #region ChoicePluItem (대상 상품 선택)
        /// <summary>
        /// 대상 상품 선택
        /// </summary>
        /// <returns></returns>
        private bool ChoicePluItem()
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                ArrayList alPluItem = (ArrayList)StateObject.GetItemObject(Column.TR_PLU.ITEM);
                Column.TR_PLU.DATA cPluItem = null;

                int nPluCount = 0;      // 상품 등록 갯수
                for (int i = 0; i < alPluItem.Count; i++)
                {
                    cPluItem = (Column.TR_PLU.DATA)alPluItem[i];

                    if (cPluItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL || cPluItem.CANCEL_DIV_MAIN == PosConst.CANCEL_DIV.CANCEL) continue;    // 지정취소
                    if (cPluItem.DC_PRMT_YN == "1") continue;

                    m_sSelRow = i.ToString();

                    nPluCount++;
                    if (nPluCount > 1) break;
                }

                if (nPluCount > 1)
                {
                    // 상품 등록 갯수가 1개 이상일때만 상품 선택
                    sRet = WinBasic.ShowForm(new string[] { FormManager.FORM_SEL_SALE_PLU });
                    if (sRet == UserCom.RST_ERR)
                    {
                        txtCardNo.SelectText();
                        return false;
                    }

                    m_sSelRow = sRet;
                }

                cPluItem = (Column.TR_PLU.DATA)alPluItem[CmUtil.IntParse(m_sSelRow)];

                m_nDestAmt = cPluItem.BILL_AMT;
                txtPayAmt.Text = m_cPosStatus.Global.NumericTOCurrency(m_nDestAmt);  // 할인 대상 금액  

                return true;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }
        #endregion

        //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 start, phj
        #region  ChoiceCpnItem (제품군 대상 상품 선택) 
        //private bool ChoiceCpnItem(string CpnItemDcType, string CpnItemDcCode, DataTable CpnItemDcInfo)
        //private bool ChoiceCpnItem(string CpnItemDcType, string CpnItemDcCode)
        private bool ChoiceCpnItem(string CpnItemDcCode)
        {
            // 제품군 코드가 내려왔을 때 상품이 두 개 이상이면
            // 상품 리스트 화면이 나오고 캐셔가 선택할 수 있도록 한다. 
            // 캐셔가 선택한 상품에만 할인을 적용해준다.
            //20171229 요건변경(할인대상 상품 중 제일 단가가 작은제품적용, 동일 판매가 일 경우 판매코드 제일 작은 상품) start, phj
            #region  기존
            /*
            string sRet = UserCom.RST_ERR;

            int nPluCount = 0; // 상품 등록 갯수
            bool ItemCheck = false; // false: 등록된상품과 일치된상품없음. true: 등록된상품과 일치된상품있음.
            string CpnItemDcType = string.Empty;

            try
            {
                DataTable dtCpnItemDcList = null;
                // 제품군의 속한 상품리스트를 가져온다.
                // 전문에 코드는 내려왔는데 제품군 마스터에 존재하지 않으면 상품코드로 간주한다.
                dtCpnItemDcList = m_cDataCommon.CpnItemDCTargetList(CpnItemDcCode); 
                if (dtCpnItemDcList == null || dtCpnItemDcList.Rows.Count == 0)
                {
                    // 상품코드
                    CpnItemDcType = "2";
                }
                else
                {
                    // 제품군 
                    CpnItemDcType = "1";
                }

                ArrayList alPluItem = (ArrayList)StateObject.GetItemObject(Column.TR_PLU.ITEM);
                Column.TR_PLU.DATA cPluItem = null;
                for (int i = 0; i < alPluItem.Count; i++)
                {
                    cPluItem = (Column.TR_PLU.DATA)alPluItem[i];

                    if (cPluItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL || cPluItem.CANCEL_DIV_MAIN == PosConst.CANCEL_DIV.CANCEL) continue;    // 지정취소
                    if (cPluItem.DC_PRMT_YN == "1") continue;

                    // 제품군
                    if (CpnItemDcType == "1")
                    {
                        foreach (DataRow dr in dtCpnItemDcList.Rows)
                        {
                            if (cPluItem.ITEM_PLU_CD == CmUtil.GetDataRowStr(dr, PosMst.MST_CPN_ITEM_GRP_MNG_DTL.DATA.ITEM_CD))
                            {
                                m_sSelRow = i.ToString();

                                //상품 갯수가 한 개인지, 아닌지 판단하고
                                //한 개 이상이면 폼을 띄워준다.
                                nPluCount++;

                                //등록 상품 중에 제품군에 속한 상품이 존재한다. true!
                                //등록 상품 중에 제품군에 속한 상품이 존재하지 않는다. false!
                                ItemCheck = true;
                                break;
                            }
                        }

                        //m_sSelRow = i.ToString();
                        //nPluCount++;
                        //if (nPluCount > 1) break;
                    }
                    //상품코드
                    else if (CpnItemDcType == "2")
                    {
                        //상품코드
                        if (CpnItemDcCode == cPluItem.ITEM_PLU_CD)
                        {
                            m_sSelRow = i.ToString();
                            ItemCheck = true;
                            break;
                        }
                    }
                }

                // 등록된 상품과 응답 전문의 상품코드가 일치.
                if (ItemCheck == true)
                {
                    // 제품군
                    if (CpnItemDcType == "1")
                    {
                        if (nPluCount > 1)
                        {
                            // 상품 등록 갯수가 1개 이상일때만 제품 군 상품 리스트 선택
                            sRet = WinBasic.ShowForm(new string[] { FormManager.FORM_SEL_SALE_PLU, CpnItemDcCode });

                            if (sRet == UserCom.RST_ERR)
                            {
                                txtCardNo.SelectText();
                                return false;
                            }

                            m_sSelRow = sRet;
                        }
                    }

                    cPluItem = (Column.TR_PLU.DATA)alPluItem[CmUtil.IntParse(m_sSelRow)];

                    m_nDestAmt = cPluItem.BILL_AMT;
                    txtPayAmt.Text = m_cPosStatus.Global.NumericTOCurrency(m_nDestAmt);  // 할인 대상 금액

                    UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                         System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                         System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                         "Online Coupon Item OK " +
                                         "/Online Coupon Dc Code : " + CpnItemDcCode +
                                         "/Online Coupon Dc Item : " + cPluItem.ITEM_PLU_CD +
                                         "/Online Coupon Dc Target Amt : " + cPluItem.BILL_AMT +
                                         "/Online Coupon Dc Target Name : " + cPluItem.ITEM_NAME);

                    return true;

                }
                // 등록된 상품과 응답 전문의 상품코드가 불일치.
                else
                {
                    UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                      System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                      System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                      "Online Coupon Item X ");

                    txtCardNo.SelectText();
                    return false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);

                return false;
            }
            */
            #endregion

            #region  변경
            string CpnItemDcType = string.Empty;
            string sItemNm = string.Empty;
            string sItemCode = string.Empty;
            bool bItemCheck = false; // false: 등록된상품과 일치된상품없음. true: 등록된상품과 일치된상품있음.
            double dPayAmt = -1;

            //#20180502 온라인쿠폰 제품군, 상품코드 할인 적용 기능 적용 start
            string sGubun = string.Empty;
            //#20180502 온라인쿠폰 제품군, 상품코드 할인 적용 기능 적용 end

            try
            {
                // 제품군의 속한 상품 리스트를 가져온다.
                // 조회응답전문에 코드는 내려왔는데 제품군 마스터에 존재하지 않으면 상품코드로 간주한다.
                DataTable dtCpnItemDcList = null;
                dtCpnItemDcList = m_cDataCommon.CpnItemDCTargetList(CpnItemDcCode);
                if (dtCpnItemDcList == null || dtCpnItemDcList.Rows.Count == 0)
                {
                    // 상품코드
                    CpnItemDcType = "2";
                }
                else
                {
                    // 제품군 
                    CpnItemDcType = "1";


                    //#20180502 온라인쿠폰 제품군, 상품코드 할인 적용 기능 적용 start 
                    DataRow dr = dtCpnItemDcList.Rows[0];
                    // 00: 일반제품군, 01: 대분류 코드 ,02: 중분류 코드 ,03: 소분류 코드
                    sGubun = CmUtil.GetDataRowStr(dr, PosMst.MST_CPN_ITEM_GRP_MNG.DATA.GUBUN);
                    //#20180502 온라인쿠폰 제품군, 상품코드 할인 적용 기능 적용 end
                }

                UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                      System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                      System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                      "OnlineCoupon Type : " + CpnItemDcType + ", Code : " + CpnItemDcCode);

                ArrayList alPluItem = (ArrayList)StateObject.GetItemObject(Column.TR_PLU.ITEM);
                Column.TR_PLU.DATA cPluItem = null;
                if (CpnItemDcType == "1")
                {
                    foreach (DataRow dr in dtCpnItemDcList.Rows)
                    {
                        for (int i = 0; i < alPluItem.Count; i++)
                        {
                            cPluItem = (Column.TR_PLU.DATA)alPluItem[i];
                            if (cPluItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL || cPluItem.CANCEL_DIV_MAIN == PosConst.CANCEL_DIV.CANCEL) continue;    // 지정취소
                            if (cPluItem.DC_PRMT_YN == "1") continue;

                            //#20180502 온라인쿠폰 제품군, 상품코드 할인 적용 기능 적용 start
                            //기존
                            //if (CmUtil.GetDataRowStr(dr, PosMst.MST_CPN_ITEM_GRP_MNG_DTL.DATA.ITEM_CD) == cPluItem.ITEM_PLU_CD)
                            //{
                            //    if (dPayAmt > -1 && dPayAmt <= cPluItem.SALE_PRC) continue;
                            //    dPayAmt = cPluItem.SALE_PRC;// 판매단가 
                            //
                            //    m_sSelRow = i.ToString();
                            //
                            //    bItemCheck = true;
                            //    sItemNm = cPluItem.ITEM_PLU_CD;
                            //    sItemCode = cPluItem.ITEM_NAME;
                            //    break;
                            //}

                            //변경
                            if (sGubun == "00")
                            {
                                if (CmUtil.GetDataRowStr(dr, PosMst.MST_CPN_ITEM_GRP_MNG_DTL.DATA.ITEM_CD) != cPluItem.ITEM_PLU_CD) continue;
                            }
                            else if (sGubun == "01")
                            {
                                if (CmUtil.GetDataRowStr(dr, PosMst.MST_CPN_ITEM_GRP_MNG_DTL.DATA.ITEM_CD) != cPluItem.L_CLSS) continue;
                            }
                            else if (sGubun == "02")
                            {
                                if (CmUtil.GetDataRowStr(dr, PosMst.MST_CPN_ITEM_GRP_MNG_DTL.DATA.ITEM_CD) != cPluItem.M_CLSS) continue;
                            }
                            else if (sGubun == "03")
                            {
                                if (CmUtil.GetDataRowStr(dr, PosMst.MST_CPN_ITEM_GRP_MNG_DTL.DATA.ITEM_CD) != cPluItem.S_CLSS) continue;
                            }


                            //#20181030 판매단가 제일 높은 것으로 원복 start
                            //기존
                            /*
                            //#20180711 단가 제일 높은것으로 변경 start
                            //기존
                            //if (dPayAmt > -1 && dPayAmt <= cPluItem.SALE_PRC) continue;
                            //변경                            
                            //#15859 유형군 쿠폰 적용 시 오류 확인요청 start
                            //적용 대상 상품 체크시 실판매금액(BILL_AMT)로 체크 하도록 변경
                            //단가가 동일한 상품이 있는 경우 수량에 따라 적용이 안되는 경우가 생김
                            //기존
                            //if (dPayAmt > -1 && dPayAmt >= cPluItem.SALE_PRC) continue;
                            //변경
                            if (dPayAmt > -1 && dPayAmt >= cPluItem.BILL_AMT) continue;
                            //#15859 유형군 쿠폰 적용 시 오류 확인요청 end
                            //#20180711 단가 제일 높은것으로 변경 end
                            */

                            //변경
                            if (dPayAmt > -1 && dPayAmt >= cPluItem.SALE_PRC) continue;
                            //#20181030 판매단가 제일 높은 것으로 원복 end

                            //#20181030 판매단가 제일 높은 것으로 원복 start
                            //기존
                            /*
                            //#15859 유형군 쿠폰 적용 시 오류 확인요청 start
                            //적용 대상 상품 체크시 실판매금액(BILL_AMT)로 체크 하도록 변경
                            //단가가 동일한 상품이 있는 경우 수량에 따라 적용이 안되는 경우가 생김
                            //기존
                            //dPayAmt = cPluItem.SALE_PRC;// 판매단가 
                            //변경
                            dPayAmt = cPluItem.BILL_AMT;// 판매단가 
                            //#15859 유형군 쿠폰 적용 시 오류 확인요청 end
                            */
                            //변경
                            dPayAmt = cPluItem.SALE_PRC;// 판매단가 
                            //#20181030 판매단가 제일 높은 것으로 원복 end

                            m_sSelRow = i.ToString();

                            bItemCheck = true;
                            sItemNm = cPluItem.ITEM_PLU_CD;
                            sItemCode = cPluItem.ITEM_NAME;
                            //#20180502 온라인쿠폰 제품군, 상품코드 할인 적용 기능 적용 start,20180511
                            //판매단가 가장 작은 제품에 적용되지 않고 첫번째 제품에 적용됨
                            //break;
                            //#20180502 온라인쿠폰 제품군, 상품코드 할인 적용 기능 적용 end,20180511

                            //#20180502 온라인쿠폰 제품군, 상품코드 할인 적용 기능 적용 end
                        }
                    }
                }
                else
                {
                    for (int i = 0; i < alPluItem.Count; i++)
                    {
                        cPluItem = (Column.TR_PLU.DATA)alPluItem[i];
                        if (cPluItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL || cPluItem.CANCEL_DIV_MAIN == PosConst.CANCEL_DIV.CANCEL) continue;    // 지정취소
                        if (cPluItem.DC_PRMT_YN == "1") continue;
                        if (cPluItem.ITEM_PLU_CD == CpnItemDcCode)
                        {
                            m_sSelRow = i.ToString();

                            bItemCheck = true;
                            sItemNm = cPluItem.ITEM_PLU_CD;
                            sItemCode = cPluItem.ITEM_NAME;
                            break;
                        }
                    }
                }


                // 등록된 상품과 응답전문의 상품코드가 일치.
                if (bItemCheck == true)
                {
                    cPluItem = (Column.TR_PLU.DATA)alPluItem[CmUtil.IntParse(m_sSelRow)];
                    m_nDestAmt = cPluItem.BILL_AMT;
                    txtPayAmt.Text = m_cPosStatus.Global.NumericTOCurrency(m_nDestAmt);  // 할인 대상 금액

                    UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                      System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                      System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                      "OnlineCoupon Item O [" + CpnItemDcCode + "] ItemNm : " + sItemNm + ", ItemCode : " + sItemCode + ", PayAmt : " + txtPayAmt.Text);
                    return true;
                }
                // 등록된 상품과 응답전문의 상품코드가 불일치.
                else
                {
                    UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                      System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                      System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                      "OnlineCoupon Item X [" + CpnItemDcCode + "]");
                    txtCardNo.SelectText();
                    return false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);

                return false;
            }
            #endregion
            //20171229 요건변경(할인대상 상품 중 제일 단가가 작은제품적용, 동일 판매가 일 경우 판매코드 제일 작은 상품) end, phj
        }
        #endregion
        //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 end, phj

        #endregion

        #region DeviceEvent 관련
        /// <summary>
        /// DeviceEvent 관련
        /// </summary>
        /// <param name="sDevice"></param>
        /// <param name="sData1"></param>
        /// <param name="sData2"></param>
        /// <param name="sData3"></param>
        public void OnDeviceEvent(string sDevice, string sData1, string sData2, string sData3)
        {
            try
            {
                if (bNotDoubleClik) return;
                bNotDoubleClik = true;

                switch (sDevice)
                {
                    case PosConst.OPOS_DEVICE.MSR:
                        this.Invoke(new EventHandler(OnMSREvent));
                        break;
                    case PosConst.OPOS_DEVICE.SCANNER:
                        this.Invoke(new EventHandler(OnScannerEvent));
                        break;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                bNotDoubleClik = false;
            }
            bNotDoubleClik = false;
        }

        /// <summary>
        /// MSR Event
        /// </summary>
        /// <param name="source"></param>
        /// <param name="e"></param>
        private void OnMSREvent(object source, EventArgs e)
        {
            try
            {
                string sMsrData = m_cDevStatus.Msr.Track2Data;
                if (sMsrData.Length > 0)
                {
                    m_sInEncData = "";
                    m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;
                    m_sInPutData = sMsrData;

                    txtCardNo.Value = m_sInPutData.Length > 16 ? m_sInPutData.Substring(0, 16) : m_sInPutData;

                    txtEditBox_EditBoxKeyDownEvent(txtCardNo, PosKey.MENU_KEY.ENTER);
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        /// <summary>
        /// 스캐너 이벤트 처리
        /// </summary>
        /// <param name="source"></param>
        /// <param name="e"></param>
        private void OnScannerEvent(object source, EventArgs e)
        {
            try
            {
                string sScanData = m_cDevStatus.Scanner.DataLabel;
                if (sScanData.Length > 0)
                {
                    m_sInEncData = "";
                    m_sInPutData = sScanData;
                    if (m_sInPutData.Length > 16 && CmUtil.IsNumber(m_sInPutData.Substring(16, 1)) == false)
                    {
                        m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_MOBILE_SWIP;
                        txtCardNo.Value = m_sInPutData.Substring(0, 16);
                    }
                    else
                    {
                        m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_KEYIN;
                        txtCardNo.Value = m_sInPutData;
                    }

                    txtEditBox_EditBoxKeyDownEvent(txtCardNo, PosKey.MENU_KEY.ENTER);
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        /// <summary>
        /// 카드 번호 암호화
        /// </summary>
        /// <param name="sInData"></param>
        /// <param name="sInMaskData"></param>
        /// <param name="sInEncData"></param>
        /// <returns></returns>
        private bool EncryptedCardNo(string sInData, ref string sInMaskData, ref string sInEncData)
        {
            string sEncData = sInData;
            bool bRet = false;
            try
            {
                UnRegIcCallback();              // IC리더 콜백 해지

                sEncData = m_cDeviceICReader.GetEncryptedCardNo(sInData).Trim();
                if (CmUtil.MidH(sEncData, 0, 2) == "00")
                {
                    sInEncData = CmUtil.MidH(sEncData, 2, 512).Trim();                          // 암호화 데이터
                    sInMaskData = CmUtil.MidH(sEncData, 514, sEncData.Length - 514).Trim();     // 마스킹 데이터
                    bRet = true;
                }
                else
                {
                    //암호화 처리 실패!
                    UserLog.WriteLogFile(UserCom.LOG_ERROR, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                        System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", "Fail =>" + sInData);
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0280);
                }
                if (txtCardNo.Value == "") tmrIcCard.Enabled = true;    // IC리더 콜백 설정
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return bRet;
        }

        /// <summary>
        /// IC 카드 정보 입력 처리
        /// </summary>
        /// <returns></returns>
        private bool GetIcCardData(bool bCancelCallBack)
        {
            try
            {
                if (bCancelCallBack == true) UnRegIcCallback(); // IC리더 콜백 해지

                txtCardNo.Value = "";
                ClearCardInfo();        // 카드 입력 정보 클리어

                string sRsvStr = "";
                if (m_cDeviceICReader.GetCardInfo_ICReader(PosConst.IC_READER_TRAN_TYPE.POINT, (int)m_nDestAmt, ref sRsvStr) == true)
                {
                    if (CmUtil.MidH(sRsvStr, 0, 2) == "00")
                    {
                        m_sInEncData = CmUtil.MidH(sRsvStr, 6, 512).Trim();
                        m_sInMaskData = CmUtil.MidH(sRsvStr, 1030, 37).Trim();
                        m_sInPutData = m_sInMaskData;
                        m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;

                        txtCardNo.Value = m_sInPutData.Length > 16 ? m_sInPutData.Substring(0, 16) : m_sInPutData;

                        return true;
                    }
                }
                if (txtCardNo.Value == "") tmrIcCard.Enabled = true;       // IC리더 콜백 설정
                // WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0321);
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }

        /// <summary>
        /// RF 카드 정보 입력 처리
        /// </summary>
        /// <returns></returns>
        private bool GetRfCardData()
        {
            try
            {
                txtCardNo.Value = "";
                ClearCardInfo();        // 카드 입력 정보 클리어

                //카드 정보 입력
                string sRsvStr = "";
                if (m_cDeviceICReader.GetRfCreditCardInfo("1", m_cTrnStatus.Head.NetSaleAmt.ToString(), "", "", "", ref sRsvStr) == false)
                {
                    if (sRsvStr != "") WinManager.ErrorMessage(sRsvStr);
                    return false;
                }

                m_sInEncData = CmUtil.MidH(sRsvStr, 2, 512).Trim();
                m_sInMaskData = CmUtil.MidH(sRsvStr, 514, 40).Trim();
                
                m_sInPutData = m_sInMaskData;
                m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_RF;

                txtCardNo.Value = m_sInPutData.Length > 16 ? m_sInPutData.Substring(0, 16) : m_sInPutData;
                return true;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }

        /// <summary>
        /// POP 카드 정보 입력 처리
        /// </summary>
        /// <returns></returns>
        private bool GetPopCardData()
        {
            string sRsvStr = "";
            try
            {
                txtCardNo.Value = "";
                ClearCardInfo();        // 카드 입력 정보 클리어

                if (m_cDeviceICReader.RfPrepaidCardInfo(ref sRsvStr) == false)
                {
                    if (sRsvStr != "") WinManager.ErrorMessage(sRsvStr);
                    return false;
                }
                if (sRsvStr.StartsWith("T") == true)
                {
                    m_sInPutData = sRsvStr.Substring(7, 16).Trim();
                }
                else if (sRsvStr.StartsWith("E") == true)
                {
                    m_sInPutData = sRsvStr.Substring(1, 20).Trim();
                }
                else
                {
                    return false;
                }

                bool bRet = EncryptedCardNo(m_sInPutData, ref m_sInMaskData, ref m_sInEncData);
                if (bRet == true)
                {
                    m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_RF;
                    txtCardNo.Text = m_sInPutData;
                }
                return bRet;

                //string sEncData = m_cDeviceICReader.GetEncryptedCardNo(m_sInPutData).Trim();
                //if (CmUtil.MidH(sEncData, 0, 2) == "00")
                //{
                //    m_sInEncData = CmUtil.MidH(sEncData, 2, 512).Trim();                          // 암호화 데이터
                //    m_sInMaskData = CmUtil.MidH(sEncData, 514, sEncData.Length - 514).Trim();     // 마스킹 데이터
                //    m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_RF;
                //    txtCardNo.Text = m_sInPutData;
                //    return true;
                //}
                //else
                //{
                //    //암호화 처리 실패!
                //    UserLog.WriteLogFile(UserCom.LOG_ERROR, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                //        System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", "Fail =>" + m_sInPutData);
                //    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0280);
                //}

            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                // 여전법 대응////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sRsvStr);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return false;
        }

        /// <summary>
        /// 전화번호 입력 처리
        /// </summary>
        /// <returns></returns>
        private bool GetPinPadData()
        {
            try
            {
                txtCardNo.Value = "";
                ClearCardInfo();        // 카드 입력 정보 클리어

                string sRsvStr = "";
                if (m_cDeviceSignPad.GetMsg_SignPad(true, MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0324), ref sRsvStr) == false)
                {
                    //WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0321);
                    return false;
                }
                txtCardNo.Value = sRsvStr;
                return true;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }
        #endregion

        private void gridList_Enter(object sender, EventArgs e)
        {
            padInPut.SetActiveFocus();
        }

        private void gridList_GridClickEvent(object sender, string rowIndex)
        {
            try
            {
                int nRow = gridList.CsmGridSelectedRowIndex;
                if (nRow < 0) return;

                string sCouponCode = gridList.CsmGridGetCell(nRow, 0);
                if (sCouponCode.Trim() != "")
                {
                    txtCardNo.Value = sCouponCode.Trim();

                    m_sInCardCoupon = sCouponCode.Trim();
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        private void lblCardNo_MouseDown(object sender, MouseEventArgs e)
        {
            //if (e.Button == System.Windows.Forms.MouseButtons.Right)
            //{
            //    m_cDevStatus.Scanner.DataLabel = "8231124183433925%";
            //    OnScannerEvent(null, null);
            //}
        }

        #region IC리더 콜백 관련
        /// <summary>
        /// IC리더 콜백 설정
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tmrIcCard_Tick(object sender, EventArgs e)
        {
            try
            {
                if (m_cDevStatus.ICReader.UseYn != true)             // 여전법 인증여부(0:MSR, 1:IC)
                {
                    tmrIcCard.Enabled = false;
                    return;
                }

                if (tmrIcCard.Tag == null || tmrIcCard.Tag.ToString() == "")
                {
                    // IC리더 콜백 설정
                    if (bNotDoubleClik) return;

                    tmrIcCard.Enabled = false;

                    //#20170918 IC 콜백 함수 변경 start
                    //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
                    //기존
                    m_cDeviceICReader.RegIcCallback(delegateReader);
                    //변경
                    //string sApprID = PosMstManager.GetMstVan(ItemConst.TR_ITEM_ID.CREDITCARD_ITEM, ItemConst.TR_ITEM_ID.CREDITCARD.CREDIT_CARD, PosMst.MST_VAN.DATA.APPR_ID);
                    //m_cDeviceICReader.RegIcCallbackCardInfo(sApprID, m_cDataService.IntParse(txtPayAmt.Text), delegateReaderCardInfo);
                    //#20170918 IC 콜백 함수 변경 end
                }
                else if (tmrIcCard.Tag.ToString() == "MSR")
                {
                    // MSR 카드 읽기
                    tmrIcCard.Enabled = false;
                    tmrIcCard.Tag = "";
                    tmrIcCard.Interval = 500;

                    SearchTxtInPut("1", null);       // 조회

                    tmrIcCard.Enabled = true;
                }
                else if (tmrIcCard.Tag.ToString() == "IC")
                {
                    // IC리더 카드 읽기
                    tmrIcCard.Enabled = false;
                    tmrIcCard.Tag = "";
                    tmrIcCard.Interval = 500;

                    bNotDoubleClik = false;
                    btnProc_Click(btnIcCard, null);
                }
                else
                    tmrIcCard.Enabled = false;

                tmrIcCard.Interval = 500;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        delegate void DelegateIcReaderCallBack(int rc, StringBuilder str);
        /// <summary>
        /// IC리더 콜백 함수
        /// </summary>
        /// <param name="num"></param>
        /// <param name="str"></param>
        public void OnIcReaderCallBack(int num, StringBuilder str)
        {
            try
            {
                if (txtCardNo.InvokeRequired)
                {
                    DelegateIcReaderCallBack d = new DelegateIcReaderCallBack(OnIcReaderCallBack);
                    this.Invoke(d, new object[] { num, str });
                }
                else
                {
                    if (bNotDoubleClik) return;
                    bNotDoubleClik = true;

                    if (num == 1)
                    {
                        // IC 카드
                        tmrIcCard.Tag = "IC";
                        tmrIcCard.Interval = 100;
                    }
                    else
                    {
                        // MSR 카드
                        if (str.ToString().StartsWith("EN") == true)
                        {
                            ClearCardInfo();        // 카드 입력 정보 클리어

                            m_sInEncData = CmUtil.MidH(str.ToString(), 0, 512).Trim();
                            m_sInMaskData = CmUtil.MidH(str.ToString(), 512, 40).Trim();
                            m_sInPutData = m_sInMaskData;
                            m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;

                            txtCardNo.Value = m_sInPutData;
                            tmrIcCard.Tag = "MSR";

                            tmrIcCard.Interval = 100;
                        }
                        else
                        {
                            tmrIcCard.Interval = 500;
                        }
                    }
                    tmrIcCard.Enabled = true;

                    bNotDoubleClik = false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                        System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                bNotDoubleClik = false;
            }
        }

        /// <summary>
        /// IC리더 콜백 해지
        /// </summary>
        private void UnRegIcCallback()
        {
            try
            {
                if (m_cDevStatus.ICReader.UseYn == true)     // 여신전문금융업법 적용여부 체크
                {
                    tmrIcCard.Enabled = false;

                    //#20170918 IC 콜백 함수 변경 start
                    //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
                    //기존
                    m_cDeviceICReader.UnRegIcCallback();
                    //변경
                    //m_cDeviceICReader.UnRegIcCallbackCardInfo();
                    //#20170918 IC 콜백 함수 변경 end
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        //#20170918 IC 콜백 함수 변경 start
        //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
        /*
        delegate void DelegateWriteLog(int returnValue, StringBuilder returnData);
        /// <summary>
        /// IC리더 콜백 함수(CardInfo)
        /// </summary>
        /// <param name="returnValue"></param>
        /// <param name="returnData"></param>
        public void OnIcReaderCallBackCardInfo(int returnValue, StringBuilder returnData)
        {
            if (txtCardNo.InvokeRequired)
            {
                DelegateWriteLog d = new DelegateWriteLog(OnIcReaderCallBackCardInfo);
                this.Invoke(d, new object[] { returnValue, returnData });
            }
            else
            {
                if (m_bCardInPut) return;
                m_bCardInPut = true;

                if (returnValue > 0)
                {
                    string sRsvStr = returnData.ToString();
                    if (CmUtil.MidH(sRsvStr, 0, 2) == "00")
                    {
                        m_sCardNo = CmUtil.MidH(sRsvStr, 6, 512).Trim();
                        txtCardNo.Value = CmUtil.MidH(sRsvStr, 1030, 37).Trim();
                        m_sIcChip = CmUtil.MidH(sRsvStr, 518, 512).Trim();
                        if (CmUtil.MidH(sRsvStr, 4, 2).Trim() == "02")
                        {
                            m_InputType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;
                        }
                        else
                        {
                            m_InputType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_IC;
                        }
                        m_sServiceCode = CmUtil.MidH(sRsvStr, 1067, 5).Trim();
                        m_sFallDiv = CmUtil.MidH(sRsvStr, 3, 1); // == "3" ? "0" : "1";

                        // IC 카드(CardInfo)
                        tmrIcCard.Tag = "ICREADER";
                        tmrIcCard.Interval = 100;
                        tmrIcCard.Enabled = true;

                        m_bCardInPut = false;
                    }
                }
            }

        }
        */
        //#20170918 IC 콜백 함수 변경 end

        #endregion

    }
}
